module UU
  module OS
    module Env

      # Specifies what to do with versions.
      class VersionStrategy

        # Do not publish. Data is stored to the private version and not published.
        DO_NOT_PUBLISH = 'DO_NOT_PUBLISH'

        # Create new version. New version is created and published.
        CREATE_NEW_VERSION = 'CREATE_NEW_VERSION'

        # Overwrite version. Current version is overwritten. If not permitted by the system, new version is created.
        OVERWRITE_VERSION = 'OVERWRITE_VERSION'

      end

    end
  end
end
