require 'uu/os/rest/dto'
require 'uu/os/uesuri'

# Module Unicorn Universe.
module UU
  
  # Module Operating System.
  module OS
    
    # Use Case Log service.
    module UseCaseLog
      
      # @see UseCaseLog#add_record
      class UseCaseLogAddRecord < UU::OS::REST::DTO
        
        # @see UseCaseLog#add_record
        attr_accessor :creation_time;
        
        # @see UseCaseLog#add_record
        attr_accessor :log_level;
        
        # @see UseCaseLog#add_record
        attr_accessor :message;
        
        # @see UseCaseLog#add_record
        attr_accessor :node_id;
        
        # @see UseCaseLog#add_record
        attr_accessor :access_role_uri;
        
        # @see UseCaseLog#add_record
        attr_accessor :access_role_name;
        
        # @see UseCaseLog#add_record
        attr_accessor :executive_role_uri;

        # @see UseCaseLog#add_record        
        # attr_accessor :executive_role_name; # this attribute will be added after uuOS 8-20
        
        # @see UseCaseLog#add_record
        attr_accessor :object_uri;
        
        # @see UseCaseLog#add_record
        attr_accessor :client_app_code;
        
        # @see UseCaseLog#add_record
        attr_accessor :app_code;
        
        # @see UseCaseLog#add_record
        attr_accessor :use_case_code;
        
        # @see UseCaseLog#add_record
        attr_accessor :use_case_name;
        
        # @see UseCaseLog#add_record
        attr_accessor :use_case_type;
        
        # @see UseCaseLog#add_record
        attr_accessor :use_case_duration;
      
        def creation_time()
          return attributes[:creationTime];
        end

        def creation_time=(value)
          attributes[:creationTime] = value;
        end

        def log_level()
          return attributes[:logLevel];
        end

        def log_level=(value)
          attributes[:logLevel] = value;
        end

        def message()
          return attributes[:message];
        end

        def message=(value)
          attributes[:message] = value;
        end

        def node_id()
          return attributes[:nodeId];
        end

        def node_id=(value)
          attributes[:nodeId] = value;
        end

        def access_role_uri()
          return attributes[:accessRoleUri];
        end

        def access_role_uri=(value)
          attributes[:accessRoleUri] = (value != nil) ? UU::OS::UESURI.new(value) : nil;
        end
        
        def access_role_name()
          return attributes[:accessRoleName];
        end
        
        def access_role_name=(value)
          attributes[:accessRoleName] = value;
        end
        
        def executive_role_uri()
          return attributes[:executiveRoleUri];
        end

        def executive_role_uri=(value)
          attributes[:executiveRoleUri] = (value != nil) ? UU::OS::UESURI.new(value) : nil;
        end
        
        # will be added after uuOS 8-20
        # def executive_role_name()
        #   return attributes[:executiveRoleName];
        # end

        # will be added after uuOS 8-20
        # def executive_role_name=(value)
        #   attributes[:executiveRoleName] = value;
        # end
        
        def object_uri()
          return attributes[:objectUri];
        end

        def object_uri=(value)
          attributes[:objectUri] = (value != nil) ? UU::OS::UESURI.new(value) : nil;
        end
        
        def client_app_code()
          return attributes[:clientAppCode];
        end

        def client_app_code=(value)
          attributes[:clientAppCode] = value;
        end

        def app_code()
          return attributes[:appCode];
        end

        def app_code=(value)
          attributes[:appCode] = value;
        end
        
        def use_case_code()
          return attributes[:useCaseCode];
        end

        def use_case_code=(value)
          attributes[:useCaseCode] = value;
        end

        def use_case_name()
          return attributes[:useCaseName];
        end

        def use_case_name=(value)
          attributes[:useCaseName] = value;
        end

        def use_case_type()
          return attributes[:useCaseType];
        end

        def use_case_type=(value)
          attributes[:useCaseType] = value;
        end
        
        def use_case_duration()
          return attributes[:useCaseDuration];
        end

        def use_case_duration=(value)
          attributes[:useCaseDuration] = value;
        end
   
      end
    end
  end
end